Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -2595,121 +2605,128 @@
         ExFreePool(r);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ExInitializeResourceLite(&r->nonpaged->load_tree_lock);
-    
+
     r->lastinode = 0;
-    
+
     if (tp) {
         RtlCopyMemory(&r->root_item, tp->item->data, min(sizeof(ROOT_ITEM), tp->item->size));
         if (tp->item->size < sizeof(ROOT_ITEM))
             RtlZeroMemory(((UINT8*)&r->root_item) + tp->item->size, sizeof(ROOT_ITEM) - tp->item->size);
-    }
-    
+    } else
+        RtlZeroMemory(&r->root_item, sizeof(ROOT_ITEM));
+
     if (!Vcb->readonly && (r->id == BTRFS_ROOT_ROOT || r->id == BTRFS_ROOT_FSTREE || (r->id >= 0x100 && !(r->id & 0xf000000000000000)))) { // FS tree root
         // FIXME - don't call this if subvol is readonly (though we will have to if we ever toggle this flag)
         get_last_inode(Vcb, r, NULL);
-        
+
         if (r->id == BTRFS_ROOT_ROOT && r->lastinode < 0x100)
             r->lastinode = 0x100;
     }
-    
+
     InsertTailList(&Vcb->roots, &r->list_entry);
-    
+
     switch (r->id) {
         case BTRFS_ROOT_ROOT:
             Vcb->root_root = r;
             break;
-            
+
         case BTRFS_ROOT_EXTENT:
             Vcb->extent_root = r;
             break;
-            
+
         case BTRFS_ROOT_CHUNK:
             Vcb->chunk_root = r;
             break;
-            
+
         case BTRFS_ROOT_DEVTREE:
             Vcb->dev_root = r;
             break;
-            
+
         case BTRFS_ROOT_CHECKSUM:
             Vcb->checksum_root = r;
             break;
-            
+
         case BTRFS_ROOT_UUID:
             Vcb->uuid_root = r;
             break;
-            
+
+        case BTRFS_ROOT_FREE_SPACE:
+            Vcb->space_root = r;
+            break;
+
         case BTRFS_ROOT_DATA_RELOC:
             Vcb->data_reloc_root = r;
+            break;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL look_for_roots(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS look_for_roots(_Requires_exclusive_lock_held_(_Curr_->tree_lock) _In_ device_extension* Vcb, _In_opt_ PIRP Irp) {
     traverse_ptr tp, next_tp;
     KEY searchkey;
     BOOL b;
     NTSTATUS Status;
-    
+
     searchkey.obj_id = 0;
     searchkey.obj_type = 0;
     searchkey.offset = 0;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
-        ERR("error - find_tree returned %08x\n", Status);
+        ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     do {
         TRACE("(%llx,%x,%llx)\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-        
+
         if (tp.item->key.obj_type == TYPE_ROOT_ITEM) {
             ROOT_ITEM* ri = (ROOT_ITEM*)tp.item->data;
-            
+
             if (tp.item->size < offsetof(ROOT_ITEM, byte_limit)) {
                 ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, offsetof(ROOT_ITEM, byte_limit));
             } else {
                 TRACE("root %llx - address %llx\n", tp.item->key.obj_id, ri->block_number);
-                
-                Status = add_root(Vcb, tp.item->key.obj_id, ri->block_number, &tp);
+
+                Status = add_root(Vcb, tp.item->key.obj_id, ri->block_number, ri->generation, &tp);
                 if (!NT_SUCCESS(Status)) {
                     ERR("add_root returned %08x\n", Status);
                     return Status;
                 }
             }
+        } else if (tp.item->key.obj_type == TYPE_ROOT_BACKREF && !IsListEmpty(&Vcb->roots)) {
+            root* lastroot = CONTAINING_RECORD(Vcb->roots.Blink, root, list_entry);
+
+            if (lastroot->id == tp.item->key.obj_id)
+                lastroot->parent = tp.item->key.offset;
         }
-    
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
-        
+
         if (b)
             tp = next_tp;
     } while (b);
-    
+
     if (!Vcb->readonly && !Vcb->data_reloc_root) {
         root* reloc_root;
         INODE_ITEM* ii;
-        ULONG irlen;
+        UINT16 irlen;
         INODE_REF* ir;
         LARGE_INTEGER time;
         BTRFS_TIME now;
-        LIST_ENTRY rollback;
-        
-        InitializeListHead(&rollback);
-        
+
         WARN("data reloc root doesn't exist, creating it\n");
-        
-        Status = create_root(Vcb, BTRFS_ROOT_DATA_RELOC, &reloc_root, FALSE, 0, Irp, &rollback);
-        
+
+        Status = create_root(Vcb, BTRFS_ROOT_DATA_RELOC, &reloc_root, FALSE, 0, Irp);
+
         if (!NT_SUCCESS(Status)) {
             ERR("create_root returned %08x\n", Status);
-            do_rollback(Vcb, &rollback);
-            goto end;
+            return Status;
         }
-        
+
         reloc_root->root_item.inode.generation = 1;
         reloc_root->root_item.inode.st_size = 3;
         reloc_root->root_item.inode.st_blocks = Vcb->superblock.node_size;
@@ -2718,17 +2735,16 @@
         reloc_root->root_item.inode.flags = 0xffffffff80000000;
         reloc_root->root_item.objid = SUBVOL_ROOT_INODE;
         reloc_root->root_item.bytes_used = Vcb->superblock.node_size;
-        
+
         ii = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_ITEM), ALLOC_TAG);
         if (!ii) {
             ERR("out of memory\n");
-            do_rollback(Vcb, &rollback);
-            goto end;
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         KeQuerySystemTime(&time);
         win_time_to_unix(time, &now);
-        
+
         RtlZeroMemory(ii, sizeof(INODE_ITEM));
         ii->generation = Vcb->superblock.generation;
         ii->st_blocks = Vcb->superblock.node_size;
@@ -2737,60 +2753,74 @@
         ii->st_atime = now;
         ii->st_ctime = now;
         ii->st_mtime = now;
-        
-        insert_tree_item(Vcb, reloc_root, SUBVOL_ROOT_INODE, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp, &rollback);
 
-        irlen = offsetof(INODE_REF, name[0]) + 2;
+        Status = insert_tree_item(Vcb, reloc_root, SUBVOL_ROOT_INODE, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            ExFreePool(ii);
+            return Status;
+        }
+
+        irlen = (UINT16)offsetof(INODE_REF, name[0]) + 2;
         ir = ExAllocatePoolWithTag(PagedPool, irlen, ALLOC_TAG);
         if (!ir) {
             ERR("out of memory\n");
-            do_rollback(Vcb, &rollback);
-            goto end;
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         ir->index = 0;
         ir->n = 2;
         ir->name[0] = '.';
         ir->name[1] = '.';
-        
-        insert_tree_item(Vcb, reloc_root, SUBVOL_ROOT_INODE, TYPE_INODE_REF, SUBVOL_ROOT_INODE, ir, irlen, NULL, Irp, &rollback);
-        
-        clear_rollback(Vcb, &rollback);
-        
+
+        Status = insert_tree_item(Vcb, reloc_root, SUBVOL_ROOT_INODE, TYPE_INODE_REF, SUBVOL_ROOT_INODE, ir, irlen, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            ExFreePool(ir);
+            return Status;
+        }
+
         Vcb->data_reloc_root = reloc_root;
         Vcb->need_write = TRUE;
     }
-    
-end:
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS find_disk_holes(device_extension* Vcb, device* dev, PIRP Irp) {
+static NTSTATUS find_disk_holes(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ device* dev, _In_opt_ PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp, next_tp;
     BOOL b;
     UINT64 lastaddr;
     NTSTATUS Status;
-    
+
     InitializeListHead(&dev->space);
-    
+
+    searchkey.obj_id = 0;
+    searchkey.obj_type = TYPE_DEV_STATS;
+    searchkey.offset = dev->devitem.dev_id;
+
+    Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
+    if (NT_SUCCESS(Status) && !keycmp(tp.item->key, searchkey))
+        RtlCopyMemory(dev->stats, tp.item->data, min(sizeof(UINT64) * 5, tp.item->size));
+
     searchkey.obj_id = dev->devitem.dev_id;
     searchkey.obj_type = TYPE_DEV_EXTENT;
     searchkey.offset = 0;
-    
+
     Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
-        ERR("error - find_tree returned %08x\n", Status);
+        ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     lastaddr = 0;
-    
+
     do {
         if (tp.item->key.obj_id == dev->devitem.dev_id && tp.item->key.obj_type == TYPE_DEV_EXTENT) {
             if (tp.item->size >= sizeof(DEV_EXTENT)) {
                 DEV_EXTENT* de = (DEV_EXTENT*)tp.item->data;
-                
+
                 if (tp.item->key.offset > lastaddr) {
                     Status = add_space_entry(&dev->space, NULL, lastaddr, tp.item->key.offset - lastaddr);
                     if (!NT_SUCCESS(Status)) {
@@ -2804,9 +2834,9 @@
                 ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DEV_EXTENT));
             }
         }
-    
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
-        
+
         if (b) {
             tp = next_tp;
             if (tp.item->key.obj_id > searchkey.obj_id || tp.item->key.obj_type > searchkey.obj_type)
@@ -2813,7 +2843,7 @@
                 break;
         }
     } while (b);
-    
+
     if (lastaddr < dev->devitem.num_bytes) {
         Status = add_space_entry(&dev->space, NULL, lastaddr, dev->devitem.num_bytes - lastaddr);
         if (!NT_SUCCESS(Status)) {
@@ -2821,195 +2851,183 @@
             return Status;
         }
     }
-    
+
     // The Linux driver doesn't like to allocate chunks within the first megabyte of a device.
-    
-    space_list_subtract2(Vcb, &dev->space, NULL, 0, 0x100000, NULL);
-    
+
+    space_list_subtract2(&dev->space, NULL, 0, 0x100000, NULL, NULL);
+
     return STATUS_SUCCESS;
 }
 
-static void add_device_to_list(device_extension* Vcb, device* dev) {
+static void add_device_to_list(_In_ device_extension* Vcb, _In_ device* dev) {
     LIST_ENTRY* le;
-    
+
     le = Vcb->devices.Flink;
-    
+
     while (le != &Vcb->devices) {
         device* dev2 = CONTAINING_RECORD(le, device, list_entry);
-        
+
         if (dev2->devitem.dev_id > dev->devitem.dev_id) {
             InsertHeadList(le->Blink, &dev->list_entry);
             return;
         }
-        
+
         le = le->Flink;
     }
-    
+
     InsertTailList(&Vcb->devices, &dev->list_entry);
 }
 
-device* find_device_from_uuid(device_extension* Vcb, BTRFS_UUID* uuid) {
+_Ret_maybenull_
+device* find_device_from_uuid(_In_ device_extension* Vcb, _In_ BTRFS_UUID* uuid) {
+    volume_device_extension* vde;
+    pdo_device_extension* pdode;
     LIST_ENTRY* le;
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
+
         TRACE("device %llx, uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n", dev->devitem.dev_id,
             dev->devitem.device_uuid.uuid[0], dev->devitem.device_uuid.uuid[1], dev->devitem.device_uuid.uuid[2], dev->devitem.device_uuid.uuid[3], dev->devitem.device_uuid.uuid[4], dev->devitem.device_uuid.uuid[5], dev->devitem.device_uuid.uuid[6], dev->devitem.device_uuid.uuid[7],
             dev->devitem.device_uuid.uuid[8], dev->devitem.device_uuid.uuid[9], dev->devitem.device_uuid.uuid[10], dev->devitem.device_uuid.uuid[11], dev->devitem.device_uuid.uuid[12], dev->devitem.device_uuid.uuid[13], dev->devitem.device_uuid.uuid[14], dev->devitem.device_uuid.uuid[15]);
-        
-        if (dev->devobj && RtlCompareMemory(&dev->devitem.device_uuid, uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
+
+        if (RtlCompareMemory(&dev->devitem.device_uuid, uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
             TRACE("returning device %llx\n", dev->devitem.dev_id);
             return dev;
         }
-        
+
         le = le->Flink;
     }
-    
-    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
-    
-    if (Vcb->devices_loaded < Vcb->superblock.num_devices && !IsListEmpty(&volumes)) {
-        LIST_ENTRY* le = volumes.Flink;
-        
-        while (le != &volumes) {
-            volume* v = CONTAINING_RECORD(le, volume, list_entry);
-            
-            if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-                RtlCompareMemory(uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)
-            ) {
-                NTSTATUS Status;
-                PFILE_OBJECT FileObject;
-                PDEVICE_OBJECT DeviceObject;
+
+    vde = Vcb->vde;
+
+    if (!vde)
+        goto end;
+
+    pdode = vde->pdode;
+
+    ExAcquireResourceSharedLite(&pdode->child_lock, TRUE);
+
+    if (Vcb->devices_loaded < Vcb->superblock.num_devices) {
+        le = pdode->children.Flink;
+
+        while (le != &pdode->children) {
+            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+            if (RtlCompareMemory(uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                 device* dev;
-                
-                Status = IoGetDeviceObjectPointer(&v->devpath, FILE_READ_ATTRIBUTES, &FileObject, &DeviceObject);
-                if (!NT_SUCCESS(Status)) {
-                    ExReleaseResourceLite(&volumes_lock);
-                    ERR("IoGetDeviceObjectPointer(%.*S) returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
-                    return NULL;
-                }
-                
-                DeviceObject = FileObject->DeviceObject;
-                
-                ObReferenceObject(DeviceObject);
-                ObDereferenceObject(FileObject);
-                
+
                 dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
                 if (!dev) {
-                    ExReleaseResourceLite(&volumes_lock);
+                    ExReleaseResourceLite(&pdode->child_lock);
                     ERR("out of memory\n");
-                    ObDereferenceObject(DeviceObject);
                     return NULL;
                 }
-                
+
                 RtlZeroMemory(dev, sizeof(device));
-                dev->devobj = DeviceObject;
+                dev->devobj = vc->devobj;
                 dev->devitem.device_uuid = *uuid;
-                dev->devitem.dev_id = v->devnum;
-                dev->seeding = v->seeding;
+                dev->devitem.dev_id = vc->devid;
+                dev->devitem.num_bytes = vc->size;
+                dev->seeding = vc->seeding;
                 dev->readonly = dev->seeding;
                 dev->reloc = FALSE;
                 dev->removable = FALSE;
-                dev->disk_num = v->disk_num;
-                dev->part_num = v->part_num;
+                dev->disk_num = vc->disk_num;
+                dev->part_num = vc->part_num;
+                dev->num_trim_entries = 0;
+                InitializeListHead(&dev->trim_list);
+
                 add_device_to_list(Vcb, dev);
                 Vcb->devices_loaded++;
-                
-                ExReleaseResourceLite(&volumes_lock);
-                
+
+                ExReleaseResourceLite(&pdode->child_lock);
+
                 return dev;
             }
-            
+
             le = le->Flink;
         }
     }
-    
-    ExReleaseResourceLite(&volumes_lock);
-    
+
+    ExReleaseResourceLite(&pdode->child_lock);
+
+end:
     WARN("could not find device with uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n",
          uuid->uuid[0], uuid->uuid[1], uuid->uuid[2], uuid->uuid[3], uuid->uuid[4], uuid->uuid[5], uuid->uuid[6], uuid->uuid[7],
          uuid->uuid[8], uuid->uuid[9], uuid->uuid[10], uuid->uuid[11], uuid->uuid[12], uuid->uuid[13], uuid->uuid[14], uuid->uuid[15]);
-    
+
     return NULL;
 }
 
-static BOOL is_device_removable(PDEVICE_OBJECT devobj) {
+static BOOL is_device_removable(_In_ PDEVICE_OBJECT devobj) {
     NTSTATUS Status;
     STORAGE_HOTPLUG_INFO shi;
-    
+
     Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_HOTPLUG_INFO, NULL, 0, &shi, sizeof(STORAGE_HOTPLUG_INFO), TRUE, NULL);
-    
+
     if (!NT_SUCCESS(Status)) {
         ERR("dev_ioctl returned %08x\n", Status);
         return FALSE;
     }
-    
+
     return shi.MediaRemovable != 0 ? TRUE : FALSE;
 }
 
-static ULONG get_device_change_count(PDEVICE_OBJECT devobj) {
+static ULONG get_device_change_count(_In_ PDEVICE_OBJECT devobj) {
     NTSTATUS Status;
     ULONG cc;
     IO_STATUS_BLOCK iosb;
-    
+
     Status = dev_ioctl(devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-    
+
     if (!NT_SUCCESS(Status)) {
         ERR("dev_ioctl returned %08x\n", Status);
         return 0;
     }
-    
+
     if (iosb.Information < sizeof(ULONG)) {
         ERR("iosb.Information was too short\n");
         return 0;
     }
-    
+
     return cc;
 }
 
-void init_device(device_extension* Vcb, device* dev, BOOL get_length, BOOL get_nums) {
+void init_device(_In_ device_extension* Vcb, _Inout_ device* dev, _In_ BOOL get_nums) {
     NTSTATUS Status;
     ULONG aptelen;
     ATA_PASS_THROUGH_EX* apte;
-    IDENTIFY_DEVICE_DATA* idd;
-    
+    STORAGE_PROPERTY_QUERY spq;
+    DEVICE_TRIM_DESCRIPTOR dtd;
+
     dev->removable = is_device_removable(dev->devobj);
     dev->change_count = dev->removable ? get_device_change_count(dev->devobj) : 0;
-    
-    if (get_length) {
-        GET_LENGTH_INFORMATION gli;
-        
-        Status = dev_ioctl(dev->devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
-                           &gli, sizeof(GET_LENGTH_INFORMATION), TRUE, NULL);
-        
-        if (!NT_SUCCESS(Status))
-            ERR("IOCTL_DISK_GET_LENGTH_INFO returned %08x\n", Status);
-        
-        dev->length = gli.Length.QuadPart;
-    }
-    
+
     if (get_nums) {
         STORAGE_DEVICE_NUMBER sdn;
-        
+
         Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
                            &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
-        
+
         if (!NT_SUCCESS(Status)) {
             WARN("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-            dev->disk_num = 0;
-            dev->part_num = 0;
+            dev->disk_num = 0xffffffff;
+            dev->part_num = 0xffffffff;
         } else {
             dev->disk_num = sdn.DeviceNumber;
             dev->part_num = sdn.PartitionNumber;
         }
     }
-    
-    dev->ssd = FALSE;
+
     dev->trim = FALSE;
     dev->readonly = dev->seeding;
     dev->reloc = FALSE;
-    
+    dev->num_trim_entries = 0;
+    dev->stats_changed = FALSE;
+    InitializeListHead(&dev->trim_list);
+
     if (!dev->readonly) {
         Status = dev_ioctl(dev->devobj, IOCTL_DISK_IS_WRITABLE, NULL, 0,
                         NULL, 0, TRUE, NULL);
@@ -3023,33 +3041,42 @@
         ERR("out of memory\n");
         return;
     }
-    
+
     RtlZeroMemory(apte, aptelen);
-    
+
     apte->Length = sizeof(ATA_PASS_THROUGH_EX);
     apte->AtaFlags = ATA_FLAGS_DATA_IN;
     apte->DataTransferLength = aptelen - sizeof(ATA_PASS_THROUGH_EX);
     apte->TimeOutValue = 3;
     apte->DataBufferOffset = apte->Length;
-    apte->CurrentTaskFile[6] = 0xec; // IDENTIFY DEVICE
-    
+    apte->CurrentTaskFile[6] = IDE_COMMAND_IDENTIFY;
+
     Status = dev_ioctl(dev->devobj, IOCTL_ATA_PASS_THROUGH, apte, aptelen,
                        apte, aptelen, TRUE, NULL);
-    
+
     if (!NT_SUCCESS(Status))
         TRACE("IOCTL_ATA_PASS_THROUGH returned %08x for IDENTIFY DEVICE\n", Status);
     else {
-        idd = (IDENTIFY_DEVICE_DATA*)((UINT8*)apte + sizeof(ATA_PASS_THROUGH_EX));
-        
-        if (idd->NominalMediaRotationRate == 1) {
-            dev->ssd = TRUE;
-            TRACE("device identified as SSD\n");
-        } else if (idd->NominalMediaRotationRate == 0)
-            TRACE("no rotational speed returned, assuming not SSD\n");
-        else
-            TRACE("rotational speed of %u RPM\n", idd->NominalMediaRotationRate);
-        
-        if (idd->DataSetManagementFeature.SupportsTrim) {
+        IDENTIFY_DEVICE_DATA* idd = (IDENTIFY_DEVICE_DATA*)((UINT8*)apte + sizeof(ATA_PASS_THROUGH_EX));
+
+        if (idd->CommandSetSupport.FlushCache) {
+            dev->can_flush = TRUE;
+            TRACE("FLUSH CACHE supported\n");
+        } else
+            TRACE("FLUSH CACHE not supported\n");
+    }
+
+    ExFreePool(apte);
+
+    spq.PropertyId = StorageDeviceTrimProperty;
+    spq.QueryType = PropertyStandardQuery;
+    spq.AdditionalParameters[0] = 0;
+
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_QUERY_PROPERTY, &spq, sizeof(STORAGE_PROPERTY_QUERY),
+                       &dtd, sizeof(DEVICE_TRIM_DESCRIPTOR), TRUE, NULL);
+
+    if (NT_SUCCESS(Status)) {
+        if (dtd.TrimEnabled) {
             dev->trim = TRUE;
             Vcb->trim = TRUE;
             TRACE("TRIM supported\n");
@@ -3056,11 +3083,11 @@
         } else
             TRACE("TRIM not supported\n");
     }
-    
-    ExFreePool(apte);
+
+    RtlZeroMemory(dev->stats, sizeof(UINT64) * 5);
 }
 
-static NTSTATUS STDCALL load_chunk_root(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS load_chunk_root(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_opt_ PIRP Irp) {
     traverse_ptr tp, next_tp;
     KEY searchkey;
     BOOL b;
@@ -3070,20 +3097,20 @@
     searchkey.obj_id = 0;
     searchkey.obj_type = 0;
     searchkey.offset = 0;
-    
+
     Vcb->data_flags = 0;
     Vcb->metadata_flags = 0;
     Vcb->system_flags = 0;
-    
+
     Status = find_item(Vcb, Vcb->chunk_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     do {
         TRACE("(%llx,%x,%llx)\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-        
+
         if (tp.item->key.obj_id == 1 && tp.item->key.obj_type == TYPE_DEV_ITEM) {
             if (tp.item->size < sizeof(DEV_ITEM)) {
                 ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DEV_ITEM));
@@ -3091,17 +3118,17 @@
                 DEV_ITEM* di = (DEV_ITEM*)tp.item->data;
                 LIST_ENTRY* le;
                 BOOL done = FALSE;
-                
+
                 le = Vcb->devices.Flink;
                 while (le != &Vcb->devices) {
                     device* dev = CONTAINING_RECORD(le, device, list_entry);
-                    
+
                     if (dev->devobj && RtlCompareMemory(&dev->devitem.device_uuid, &di->device_uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                         RtlCopyMemory(&dev->devitem, tp.item->data, min(tp.item->size, sizeof(DEV_ITEM)));
-                        
+
                         if (le != Vcb->devices.Flink)
-                            init_device(Vcb, dev, TRUE, TRUE);
-                        
+                            init_device(Vcb, dev, TRUE);
+
                         done = TRUE;
                         break;
                     }
@@ -3108,51 +3135,45 @@
 
                     le = le->Flink;
                 }
-                
-                if (!done) {
-                    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
-                    
-                    if (!IsListEmpty(&volumes) && Vcb->devices_loaded < Vcb->superblock.num_devices) {
-                        LIST_ENTRY* le = volumes.Flink;
-                        
-                        while (le != &volumes) {
-                            volume* v = CONTAINING_RECORD(le, volume, list_entry);
-            
-                            if (RtlCompareMemory(&di->device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-                                PFILE_OBJECT FileObject;
-                                PDEVICE_OBJECT DeviceObject;
+
+                if (!done && Vcb->vde) {
+                    volume_device_extension* vde = Vcb->vde;
+                    pdo_device_extension* pdode = vde->pdode;
+
+                    ExAcquireResourceSharedLite(&pdode->child_lock, TRUE);
+
+                    if (Vcb->devices_loaded < Vcb->superblock.num_devices) {
+                        le = pdode->children.Flink;
+
+                        while (le != &pdode->children) {
+                            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+                            if (RtlCompareMemory(&di->device_uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                                 device* dev;
-                                
-                                Status = IoGetDeviceObjectPointer(&v->devpath, FILE_READ_DATA | FILE_WRITE_DATA, &FileObject, &DeviceObject);
-                                if (!NT_SUCCESS(Status)) {
-                                    ExReleaseResourceLite(&volumes_lock);
-                                    ERR("IoGetDeviceObjectPointer(%.*S) returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
-                                    return Status;
-                                }
-                                
-                                DeviceObject = FileObject->DeviceObject;
-                                
-                                ObReferenceObject(DeviceObject);
-                                ObDereferenceObject(FileObject);
-                                
+
                                 dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
                                 if (!dev) {
-                                    ExReleaseResourceLite(&volumes_lock);
+                                    ExReleaseResourceLite(&pdode->child_lock);
                                     ERR("out of memory\n");
-                                    ObDereferenceObject(DeviceObject);
                                     return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 RtlZeroMemory(dev, sizeof(device));
-                               
-                                dev->devobj = DeviceObject;
+
+                                dev->devobj = vc->devobj;
                                 RtlCopyMemory(&dev->devitem, di, min(tp.item->size, sizeof(DEV_ITEM)));
-                                dev->seeding = v->seeding;
-                                init_device(Vcb, dev, FALSE, FALSE);
+                                dev->seeding = vc->seeding;
+                                init_device(Vcb, dev, FALSE);
 
-                                dev->length = v->length;
-                                dev->disk_num = v->disk_num;
-                                dev->part_num = v->part_num;
+                                if (dev->devitem.num_bytes > vc->size) {
+                                    WARN("device %llx: DEV_ITEM says %llx bytes, but Windows only reports %llx\n", tp.item->key.offset,
+                                         dev->devitem.num_bytes, vc->size);
+
+                                    dev->devitem.num_bytes = vc->size;
+                                }
+
+                                dev->disk_num = vc->disk_num;
+                                dev->part_num = vc->part_num;
                                 add_device_to_list(Vcb, dev);
                                 Vcb->devices_loaded++;
 
